<?php

##################################################
#
# Copyright (c) 2004-2005 James Hunt and the OIC Group, Inc.
#
# This file is part of Exponent
#
# Exponent is free software; you can redistribute
# it and/or modify it under the terms of the GNU
# General Public License as published by the Free
# Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# Exponent is distributed in the hope that it
# will be useful, but WITHOUT ANY WARRANTY;
# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR
# PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU
# General Public License along with Exponent; if
# not, write to:
#
# Free Software Foundation, Inc.,
# 59 Temple Place,
# Suite 330,
# Boston, MA 02111-1307  USA
#
# $Id: save_gallery.php,v 1.5 2005/02/24 20:14:14 filetreefrog Exp $
##################################################

if (!defined("PATHOS")) exit("");

$gallery = null;
if (isset($_POST['id'])) {
	$gallery = $db->selectObject("imagegallery_gallery","id=".$_POST['id']);
	$loc = unserialize($gallery->location_data);
	$loc->int = $gallery->id;
} else {
	$gallery->location_data = serialize($loc);
}

if (pathos_permissions_check("edit",$loc)) {
	
	$gallery = imagegallery_gallery::update($_POST,$gallery);
	
	if (isset($gallery->id)) {
		$db->updateObject($gallery,"imagegallery_gallery");
	} else {
		$id = $db->insertObject($gallery,"imagegallery_gallery");
	
		if (!defined("SYS_FILES")) include_once(BASE."subsystems/files.php");
		
		$directory = "files/imagegallerymodule/" . $loc->src . "/gallery". $id."/.thumbs";
		if (!file_exists(BASE.$directory)) {
			switch(pathos_files_makeDirectory($directory)) {
				case SYS_FILES_FOUNDFILE:
					echo "Found a file in the directory path.";
					$db->delete("imagegallery_gallery","id=$id");
					return;
				case SYS_FILES_NOTWRITABLE:
					echo "Unable to create directory to store files in.";
					$db->delete("imagegallery_gallery","id=$id");
					return;
			}
		}
		// Assign permissions -- need to create an internal loc
		$iloc = pathos_core_makeLocation($loc->mod,$loc->src,$id);
		foreach (array_keys(imagegallerymodule::permissions($id)) as $perm) {
			pathos_permissions_grant($user,$perm,$iloc);
		}
		pathos_permissions_triggerSingleRefresh($user);
	}
	pathos_flow_redirect();
} else {
	echo SITE_403_HTML;
}

?>